#class auto

int ReadAD ( int Channel );
int SwapBytes ( int i );


#define SPI_SER_B
#define SPI_CLK_DIVISOR			5
#use SPI.LIB


void initAD()
{
// set up chip select port
	BitWrPortI ( PDDR, &PDDRShadow, 1, 0 );	// turn off /CS (1=off)
	BitWrPortI ( PDDCR, &PDDCRShadow, 0, 0 );	// bit 0 = "normal" output
	WrPortI ( PDCR, &PDCRShadow, 0 );			// bits 0..3 = clocked by perclk/2
	BitWrPortI ( PDDDR, &PDDDRShadow, 1, 0 );	// bit 0 = output
	SPIinit();
}

void main ()
{
	int Value;
	float volts, ScaleFactor;


	ScaleFactor = 5.0/4096.0;

   initAD();

	while (1)
	{
		Value = ReadAD ( 0 );
		volts = (float) Value * ScaleFactor;
		printf ( "Value = %5.3f  \r", volts );
	}
}


#define START		0x80
#define SINGLE		0x40

int ReadAD ( int Channel)
{
	int Command, j;
	struct									// structure for returned data
	{	char	b;
		int	i;
	} Data;

	Command = START|SINGLE | ((Channel/4)<<5) | ((Channel/2)<<4) | ((Channel&1)<<3);
	Command <<= 3;							// shift so result comes back LSB justified
	Command = SwapBytes ( Command );	// adjust so high byte goes first


	BitWrPortI ( PDDR, &PDDRShadow, 0, 0 );	// enable /CS
	SPIWrRd ( &Command, &Data, 3 );				// 3rd xmit byte is "don't care"
	BitWrPortI ( PDDR, &PDDRShadow, 1, 0 );	// turn off /CS (1=off)
	j = Data.i;
	j = SwapBytes ( j ) & 0x0FFF;					// put LSB first and keep only 12 bits
   return(j);
}

// swap the high and low bytes of an int
// enter and exit with the int in HL
#asm
SwapBytes::
	ld		a, L		; save the low byte
	ld		L, H		; copy high byte to low byte
	ld		H, A		; copy saved low byte to high byte
	ret
#endasm